/*
 *;
 *; input:
 *; a0 - 16 bit data
 *; a1 - 14 bit buffer1
 *; a2 - 14 bit buffer2
 *; d0.l - datasize (number of words !!)
 *; d1.w - boostfactor
 *; exit:  d0.b - volume sum
 */

	xdef	_c16to14

_c16to14:
	movem.l	d0-a6,-(a7)

	cmp.w	#100,d1
	beq	.noboost

	ext.l	d1

	lsl.l	#7,d1
	divs.w	#100, d1

	move.l	d0,d3
	move.l	a0,a3
.boost:
	move.w	(a0),d2
	ext.l	d2
	muls.w	d1,d2

	cmp.l	#(32767*128),d2
	bmi.s	.positive_ok	;
	move.l	#(32767*128),d2
	bra.s	.div
.positive_ok:
	cmp.l	#-(32676*128),d2
	bpl.s	.div	;
	move.l	#-(32676*128),d2
.div:
	asr.l	#7,d2
	move.w	d2,(a0)+
	dbf	d0,.boost

	move.l	d3,d0
	move.l	a3,a0

.noboost:
	lsl.l	#1,d0

/*
 *; inputs:
 *;	a0 - pointer to 16 bit in FastRam (APTR)
 *;	a1 - pointer to 8 bit in ChipRam (APTR)
 *;	a2 - poniter to 6 bit in ChipRam (APTR)
 *;	d0 - lenght of 16bit area in bytes (ULONG)
 *;
 *; note:
 *;	d0 - max 524288
 */

_16to14:
	lsr.l	#3,d0
	subq.l	#1,d0
	move.l	#0xff00ff00,d5
	move.l	#0x3f3f3f3f,d6
.lp:	move.l	(a0)+,d1
	move.l	(a0)+,d2
	move.w	d1,d3
	swap	d2
	move.w	d2,d1
	move.w	d3,d2
	swap	d2
	move.l	d1,d3
	move.l	d2,d4
	and.l	d5,d1
	and.l	d5,d2
	eor.l	d1,d3
	eor.l	d2,d4
	lsr.l	#8,d2
	or.l	d2,d1
	move.l	d1,(a2)+
	lsl.l	#8,d3
	or.l	d4,d3
	lsr.l	#2,d3
	and.l	d6,d3
	move.l	d3,(a1)+
	dbf	d0,.lp
	movem.l	(a7)+,d0-a6
	rts


