/*
 * =-=-=-=-=-=-=-=-=-=-=-  NOTICE  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * The following is the license that applies to this copy of the Prayer2
 * software.  For a license to use the Prayer2 software under conditions
 * other than those described here, please contact MindNever Software at
 * following addresses:
 *
 * MindNever Software <info@mindnever.org>
 * MindNever Software +381 63 550-161 or +381 64 220-7115
 * 
 * =-=-=-=-=-=-=-=-=-=-  COPYRIGHT  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * Prayer2 is:
 *   Copyright (c) 1999-2001 by Tamara Cetinjski <tamara@mindnever.org>
 *   Copyright (c) 2001-2002 by Vladimir Zidar <mr_W@mindnever.org>
 *   Copyright (c) 1999-2002 by MindNever Software Group <info@mindnever.org>
 *
 * Tamara Cetinjski is
 *   Copyright (c) 1999-2002 by Vladimir Zidar <mr_W@mindnever.org>
 *
 *
 * =-=-=-=-=-=-=-=-=-=-  LICENSE  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Redistributions in any form must be accompanied by information on
 *    how to obtain complete source code for the Prayer2 software and any
 *    accompanying software that uses the Prayer2 software.  The source code
 *    must either be included in the distribution or be available for no
 *    more than the cost of distribution plus a nominal fee, and must be
 *    freely redistributable under reasonable conditions.  For an
 *    executable file, complete source code means the source code for all
 *    modules it contains.  It does not include source code for modules or
 *    files that typically accompany the major components of the operating
 *    system on which the executable file runs.
 *
 * =-=-=-=-=-=-=-=-=-=-  NO WARRANTY =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= 
 *
 * THIS SOFTWARE IS PROVIDED BY MINDNEVER SOFTWARE ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
 * NON-INFRINGEMENT, ARE DISCLAIMED.  IN NO EVENT SHALL MINDNEVER SOFTWARE
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, HAIR, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
#ifndef _PRAYERLISTCLASS_H_
#define _PRAYERLISTCLASS_H_

struct ListNode {
		struct Node node;
		char *storage;
	};

struct DragMark {
		LONG Nr, Scroll;
		LONG BgPen, FgPen;
		struct Rectangle Rect;
		struct Node *This, *InsAfter;
	};

Class	*MakePrayerListClass(void);
void	 FreePrayerListClass(Class *PrayerListClass);

#define PLA_Dummy	(TAG_USER | ('P' << 16) | ('L' << 8))

#define	PLA_Selected	(PLA_Dummy + 1)
#define	PLA_Top				(PLA_Dummy + 2)
#define	PLA_Visible		(PLA_Dummy + 3)
#define PLA_Highlighted	(PLA_Dummy + 4)
#define PLA_MakeVisible	(PLA_Dummy + 5)
#define PLA_Items			(PLA_Dummy + 6)
#define	PLA_Total			(PLA_Dummy + 7)
#define PLA_TextFont	(PLA_Dummy + 8)
#define	PLA_FgPen			(PLA_Dummy + 9)
#define	PLA_BgPen			(PLA_Dummy + 10)
#define	PLA_FgPenS		(PLA_Dummy + 11)
#define	PLA_BgPenS		(PLA_Dummy + 12)
#define	PLA_FgPenH		(PLA_Dummy + 13)
#define	PLA_BgPenH		(PLA_Dummy + 14)
#define	PLA_SelectedPtr (PLA_Dummy + 15)
#define PLA_HighlightedPtr	(PLA_Dummy + 16)
#define PLA_Event	(PLA_Dummy + 17)
#define PLA_Dragging (PLA_Dummy + 18)
#define PLA_ItemHeight	(PLA_Dummy + 19)
#define PLA_ItemWidth	(PLA_Dummy + 20)
#define PLA_DragMark (PLA_Dummy + 21)
#define PLA_Bob (PLA_Dummy + 22)


#define PLE_DOWN		1
#define PLE_UP			2
#define PLE_CANCEL	3
#define PLE_MOVE		4
#define PLE_IGNORE	~0

#endif /* _PRAYERLISTCLASS_H_ */
