/*
 * =-=-=-=-=-=-=-=-=-=-=-  NOTICE  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * The following is the license that applies to this copy of the Prayer2
 * software.  For a license to use the Prayer2 software under conditions
 * other than those described here, please contact MindNever Software at
 * following addresses:
 *
 * MindNever Software <info@mindnever.org>
 * MindNever Software +381 63 550-161 or +381 64 220-7115
 * 
 * =-=-=-=-=-=-=-=-=-=-  COPYRIGHT  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * Prayer2 is:
 *   Copyright (c) 1999-2001 by Tamara Cetinjski <tamara@mindnever.org>
 *   Copyright (c) 2001-2002 by Vladimir Zidar <mr_W@mindnever.org>
 *   Copyright (c) 1999-2002 by MindNever Software Group <info@mindnever.org>
 *
 * Tamara Cetinjski is
 *   Copyright (c) 1999-2002 by Vladimir Zidar <mr_W@mindnever.org>
 *
 *
 * =-=-=-=-=-=-=-=-=-=-  LICENSE  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Redistributions in any form must be accompanied by information on
 *    how to obtain complete source code for the Prayer2 software and any
 *    accompanying software that uses the Prayer2 software.  The source code
 *    must either be included in the distribution or be available for no
 *    more than the cost of distribution plus a nominal fee, and must be
 *    freely redistributable under reasonable conditions.  For an
 *    executable file, complete source code means the source code for all
 *    modules it contains.  It does not include source code for modules or
 *    files that typically accompany the major components of the operating
 *    system on which the executable file runs.
 *
 * =-=-=-=-=-=-=-=-=-=-  NO WARRANTY =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= 
 *
 * THIS SOFTWARE IS PROVIDED BY MINDNEVER SOFTWARE ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
 * NON-INFRINGEMENT, ARE DISCLAIMED.  IN NO EVENT SHALL MINDNEVER SOFTWARE
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, HAIR, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
#include <exec/memory.h>
#include <stdio.h>
#include <string.h>

#include <proto/intuition.h>
#include <proto/graphics.h>
#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/gadtools.h>
#include "pbar.h"

struct pbar {
		struct Window *win;
		UWORD	x,y,w,h;
		struct DrawInfo *dri;
		APTR *vi;
		struct Screen *scr;
		UWORD	bx,by,bw,bh;
	};

#if 0
main()
{
APTR pbar;
int i;
char ab[32];

if(pbar = CreateProgressBar(NULL, "Loading robe ...")) {
		for(i = 0; i <= 100; i++) {
				sprintf(ab, "%ld%%", i);
				UpdateProgressBar(pbar, i, ab);
				Delay(1);
			}
		Delay(100);
		EndProgressBar(pbar);
	}
}
#endif

APTR CreateProgressBar(struct Screen *where, char *title)
{
struct pbar *pbar;
struct Screen *scr = NULL;
ULONG i;
UWORD x, y;
UWORD	pattern[2] = {0xaaaa,0x5555};
APTR pt_old;

if(pbar = AllocVec(sizeof(*pbar), MEMF_CLEAR)) {
		if(where == NULL) {
				scr = LockPubScreen(NULL);
				where = scr;
			}
		if(where) {
				pbar->w = (where->Width >> 3) + 16;
				pbar->h = (where->RastPort.Font->tf_YSize) + 16;

//				pbar->x = (where->Width - pbar->w) >> 1;
//				pbar->y = (where->Height - pbar->h) >> 1;
				pbar->x = where->MouseX;
				pbar->y = where->MouseY;

				pbar->bw = pbar->w - 10;
				pbar->bh = pbar->h - 10;
				pbar->bx = (pbar->w - pbar->bw) / 2;
				pbar->by = (pbar->h - pbar->bh) / 2;

				pbar->scr = where;

				if(pbar->win = OpenWindowTags(NULL, WA_Width, pbar->w,
																			WA_Height, pbar->h,
																			WA_Left, pbar->x,
																			WA_Top, pbar->y,
																			WA_Flags, WFLG_BORDERLESS,
																			WA_CustomScreen, where,
																			TAG_DONE)) {

						SetFont(pbar->win->RPort, where->RastPort.Font);
						pbar->dri = GetScreenDrawInfo(where);
						pbar->vi = GetVisualInfoA(where, NULL);

						pt_old = pbar->win->RPort->AreaPtrn;
						i = pbar->win->RPort->AreaPtSz;
						pbar->win->RPort->AreaPtrn = &pattern[0];
						pbar->win->RPort->AreaPtSz = 1;
						SetAPen(pbar->win->RPort, pbar->dri->dri_Pens[SHINEPEN]);
						RectFill(pbar->win->RPort, 0, 0, pbar->w - 1, pbar->h - 1);

						pbar->win->RPort->AreaPtrn = pt_old;
						pbar->win->RPort->AreaPtSz = i;


						i = strlen(title);

						x = (pbar->w - TextLength(pbar->win->RPort, title, i)) / 2;
						y = pbar->win->RPort->Font->tf_Baseline + 4;

						SetDrMd(pbar->win->RPort, JAM1);

//						SetAPen(pbar->win->RPort, pbar->dri->dri_Pens[TEXTPEN]);
//						Move(pbar->win->RPort, x, y);		
//						Text(pbar->win->RPort, title, i);

//						SetAPen(pbar->win->RPort, pbar->dri->dri_Pens[SHINEPEN]);
//						Move(pbar->win->RPort, x - 1, y - 1);		
//						Text(pbar->win->RPort, title, i);

						EraseRect(pbar->win->RPort, pbar->bx - 2 , pbar->by - 2, pbar->bx + pbar->bw + 1, pbar->by + pbar->bh + 1);

						DrawBevelBox(pbar->win->RPort, 0, 0, pbar->w, pbar->h, GT_VisualInfo, pbar->vi, TAG_DONE);
						DrawBevelBox(pbar->win->RPort, pbar->bx - 2, pbar->by - 2, pbar->bw + 4, pbar->bh + 4, GT_VisualInfo, pbar->vi, GTBB_Recessed, TRUE, TAG_DONE);
					}
			} else {
				FreeVec(pbar);
				pbar = NULL;
			}
		if(scr)
			UnlockPubScreen(NULL, scr);
	}
return(pbar);
}

ULONG UpdateProgressBar(APTR p, UWORD perc, char *text)
{
ULONG x, i;
struct pbar *pbar = p;

if(pbar) {
		if(perc > 100)
			perc = 100;
		x = ((pbar->bw - 2) * perc) / 100;
		SetAPen(pbar->win->RPort, pbar->dri->dri_Pens[FILLPEN]);

		RectFill(pbar->win->RPort, pbar->bx + 1, pbar->by, pbar->bx + x - 1, pbar->by + pbar->bh - 1);
		EraseRect(pbar->win->RPort, pbar->bx + x , pbar->by, pbar->bx + pbar->bw - 3, pbar->by + pbar->bh - 1);

		DrawBevelBox(pbar->win->RPort, pbar->bx + 1, pbar->by, x, pbar->bh, GT_VisualInfo, pbar->vi, TAG_DONE);
		if(text) {
				SetAPen(pbar->win->RPort, pbar->dri->dri_Pens[FILLTEXTPEN]);
				i = strlen(text);
				Move(pbar->win->RPort, 
						pbar->bx + (pbar->bw - TextLength(pbar->win->RPort, text, i)) / 2,
						pbar->by + (pbar->bh - pbar->win->RPort->Font->tf_YSize) / 2 +
						pbar->win->RPort->Font->tf_Baseline);
				Text(pbar->win->RPort, text, i);
			}
	}
return(0);
}

void EndProgressBar(APTR p)
{
struct pbar *pbar = p;
if(pbar) {
		if(pbar->dri)
			FreeScreenDrawInfo(pbar->scr, pbar->dri);
		FreeVisualInfo(pbar->vi);
		if(pbar->win)
			CloseWindow(pbar->win);
		FreeVec(pbar);
	}
}
