/*
 * =-=-=-=-=-=-=-=-=-=-=-  NOTICE  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * The following is the license that applies to this copy of the Prayer2
 * software.  For a license to use the Prayer2 software under conditions
 * other than those described here, please contact MindNever Software at
 * following addresses:
 *
 * MindNever Software <info@mindnever.org>
 * MindNever Software +381 63 550-161 or +381 64 220-7115
 * 
 * =-=-=-=-=-=-=-=-=-=-  COPYRIGHT  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * Prayer2 is:
 *   Copyright (c) 1999-2001 by Tamara Cetinjski <tamara@mindnever.org>
 *   Copyright (c) 2001-2002 by Vladimir Zidar <mr_W@mindnever.org>
 *   Copyright (c) 1999-2002 by MindNever Software Group <info@mindnever.org>
 *
 * Tamara Cetinjski is
 *   Copyright (c) 1999-2002 by Vladimir Zidar <mr_W@mindnever.org>
 *
 *
 * =-=-=-=-=-=-=-=-=-=-  LICENSE  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Redistributions in any form must be accompanied by information on
 *    how to obtain complete source code for the Prayer2 software and any
 *    accompanying software that uses the Prayer2 software.  The source code
 *    must either be included in the distribution or be available for no
 *    more than the cost of distribution plus a nominal fee, and must be
 *    freely redistributable under reasonable conditions.  For an
 *    executable file, complete source code means the source code for all
 *    modules it contains.  It does not include source code for modules or
 *    files that typically accompany the major components of the operating
 *    system on which the executable file runs.
 *
 * =-=-=-=-=-=-=-=-=-=-  NO WARRANTY =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= 
 *
 * THIS SOFTWARE IS PROVIDED BY MINDNEVER SOFTWARE ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
 * NON-INFRINGEMENT, ARE DISCLAIMED.  IN NO EVENT SHALL MINDNEVER SOFTWARE
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, HAIR, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
#include	<utility/tagitem.h>

#ifndef MAKE_ID
#define	MAKE_ID(a,b,c,d) (((a) << 24) | ((b) << 16) | ((c) << 8) | (d))
#endif


#define	PPL_TYPE_DECODER	1
#define PPL_TYPE_EXPORT		2

// -- common --

#define PPL_Name				(TAG_USER+99)   //    ti_Data is char *
#define	PPL_Author			(TAG_USER+100)  //    ti_Data is char *
#define	PPL_Description (TAG_USER+101)  //    ti_Data is char *
#define PPL_Title				(TAG_USER+102)  //    ti_Data is char *

// -- type 1 specific --
/////////////////////////////////////////////////////////////////////////
//
#define	PPL_OpenFunc		(TAG_USER+103)
//
// ti_Data is ptr to function:
// APTR pplOpenFunc(register __a0 struct dec_request *req,
//                   register __a1 struct dec_status *dec,
//                   register __a2 struct dec_tags *tags);
//
/////////////////////////////////////////////////////////////////////////
//
#define	PPL_DecodeFunc	(TAG_USER+104)
//
// ti_Data is ptr to function:
// LONG pplDecodeFunc(register __a0 APTR stream, register __a1 struct dec_buffer *fb);
//
/////////////////////////////////////////////////////////////////////////
//
#define PPL_SeekFunc		(TAG_USER+105)
//
// ti_Data is ptr to function:
// LONG pplSeekFunc(register __a0 APTR stream, register __d0 ULONG ms_position);
//
/////////////////////////////////////////////////////////////////////////
//
#define PPL_TimeFunc		(TAG_USER+106)
//
// ti_Data is ptr to function:
// LONG pplTimeFunc(register __a0 APTR stream);
//
/////////////////////////////////////////////////////////////////////////
//
#define PPL_CloseFunc		(TAG_USER+107)
//
// ti_Data is ptr to function:
// void pplCloseFunc(register __a0 APTR stream);
//
/////////////////////////////////////////////////////////////////////////
//
#define PPL_BoostFunc (TAG_USER+108)
//
// ti_Data is ptr to function:
// void pplBoostFunc(register __a0 APTR stream, register __d0 UWORD value);
//
/////////////////////////////////////////////////////////////////////////
//
#define PPL_ConfigTag					(TAG_USER+109)
// unique identifier (char *) for configuration data. (f.ex. "cdda.ppl")
#define PPL_ConfigTemplate		(TAG_USER+110)
// ti_Data is ptr configuration template (dos.library notation with
// extensions)
// Example:
// DEVICE,UNIT/N{0-9999},MIXFREQ/N{1000-44100}
//
#define	PPL_PlayListExtra		(TAG_USER+111)
// ti_Data is (char *) to title for extra playlist load function
//
#define PPL_PlayListLoadFunc	(TAG_USER+112)
// ti_Data is ptr to function
// LONG pplPlayListLoadFunc(register __a0 struct List *where, register __a1 APTR MemoryPool);
//
/////////////////////////////////////////////////////////////////////////
//
//
#define	PPL_ExamineFunc						(TAG_USER+113)
// ti_Data is ptr to function
//
// BOOL __asm pplExamineFunc(register __a0 UBYTE *databuffer, register __d0 ULONG size);
//
//
/////////////////////////////////////////////////////////////////////////
//                      TYPE 2 specific
/////////////////////////////////////////////////////////////////////////
//
#define PPL_ExportOpenFunc			(TAG_USER+114)
//
// APTR __asm pplExportOpenFunc(register __a0 char *filename,
//															register __d0 ULONG frequency,
//															register __d1 UBYTE channels);
//
/////////////////////////////////////////////////////////////////////////
//
#define PPL_ExportWriteFunc			(TAG_USER+115)
//
// LONG __asm pplExportWriteFunc(register __a0 APTR handle,
//															 register __a1 struct dec_buffer *buffer);
//
/////////////////////////////////////////////////////////////////////////
//
#define PPL_ExportCloseFunc			(TAG_USER+116)
//
// void __asm pplExportCloseFunc(register __a0 APTR handle);
//
/////////////////////////////////////////////////////////////////////////




struct dec_request {
		UBYTE	*filename;
		UBYTE	quality1, channels1, freqdiv1; // used for layer3
		UBYTE	quality2, channels2, freqdiv2; // for layer1 & 2
	};

struct dec_status {
		ULONG	duration;
		ULONG	frequency;
		UBYTE	channels;
		UBYTE	quality;
		char	*error;
	};
struct dec_tags {
		char	*Artist;
		char	*Title;
		char	*Album;
		char	*Other;
		ULONG	Year;
	};

struct dec_buffer {
		LONG	Size;
		WORD	*Data_r;
		WORD	*Data_l;
	};

////////////////////////////////
// 

#define	PPL_MAGIC_LONG	MAKE_ID('P','P','L','G')

struct PrayerPluginTag {
		UWORD	MatchWord;	// illegal 0x4AFC
		ULONG	MagicLong;	// PPLG
		struct PrayerPluginTag *Link;
		UBYTE	Type;
		BYTE	Pri;
		struct TagItem *Tags;		
	};

//
////////////////////////////////
