/*
 * =-=-=-=-=-=-=-=-=-=-=-  NOTICE  =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * The following is the license that applies to this copy of the Prayer2
 * software.  For a license to use the Prayer2 software under conditions
 * other than those described here, please contact MindNever Software at
 * following addresses:
 *
 * MindNever Software <info@mindnever.org>
 * MindNever Software +381 63 550-161 or +381 64 220-7115
 * 
 * =-=-=-=-=-=-=-=-=-=-  COPYRIGHT  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * Prayer2 is:
 *   Copyright (c) 1999-2001 by Tamara Cetinjski <tamara@mindnever.org>
 *   Copyright (c) 2001-2002 by Vladimir Zidar <mr_W@mindnever.org>
 *   Copyright (c) 1999-2002 by MindNever Software Group <info@mindnever.org>
 *
 * Tamara Cetinjski is
 *   Copyright (c) 1999-2002 by Vladimir Zidar <mr_W@mindnever.org>
 *
 *
 * =-=-=-=-=-=-=-=-=-=-  LICENSE  -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Redistributions in any form must be accompanied by information on
 *    how to obtain complete source code for the Prayer2 software and any
 *    accompanying software that uses the Prayer2 software.  The source code
 *    must either be included in the distribution or be available for no
 *    more than the cost of distribution plus a nominal fee, and must be
 *    freely redistributable under reasonable conditions.  For an
 *    executable file, complete source code means the source code for all
 *    modules it contains.  It does not include source code for modules or
 *    files that typically accompany the major components of the operating
 *    system on which the executable file runs.
 *
 * =-=-=-=-=-=-=-=-=-=-  NO WARRANTY =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= 
 *
 * THIS SOFTWARE IS PROVIDED BY MINDNEVER SOFTWARE ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
 * NON-INFRINGEMENT, ARE DISCLAIMED.  IN NO EVENT SHALL MINDNEVER SOFTWARE
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, HAIR, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
#ifndef _PRAYER2_PREFS_H_
#define _PRAYER2_PREFS_H_

#include	<exec/lists.h>

struct	PrayerPrefs	{
	UBYTE		Layer3ForceMono, Layer3FreqDiv, Layer3Qual;
	UBYTE		Layer12ForceMono, Layer12FreqDiv, Layer12Qual;
	UWORD		AutoFadeIn;
	UWORD		AutoFadeOut;
	UWORD		AudioDriverId;
	char		*Robe;
	char		*Screen;
	UBYTE		RemapFlag;
	BYTE		RemapPrecision;
	struct	List	Plugins;
	BOOL	RTG;
	UWORD		RefreshRate;
	ULONG	Flags;
	char		*CapturePlugin;
	char		*CapturePath;
	BYTE	PlayerPri;
	BYTE	Dummy0;
	ULONG MixFreq; // for AHI
	ULONG AudioID; // for AHI
	struct {
			char Key[32];
			UBYTE Global;
			UBYTE	Repeat;
		} *Hotkeys; // PRHK_MAX
	};

enum {
		PRHK_POPUP=0,
		PRHK_HIDE,
		PRHK_PLAY,
		PRHK_STOP,
		PRHK_PAUSE,
		PRHK_NEXT,
		PRHK_PREV,
		PRHK_QUIT,
		PRHK_ADDFILES,
		PRHK_PLAYMODE,
		PRHK_REM,
		PRHK_EXTREM,
		PRHK_LOADLIST,
		PRHK_EXTLOADLIST,
		PRHK_SAVELIST,
		PRHK_SORTLIST,
		PRHK_PREFS,
		PRHK_ABOUT,
		PRHK_VOLUME_UP,
		PRHK_VOLUME_DOWN,
		PRHK_POSITION_UP,
		PRHK_POSITION_DOWN,
		PRHK_LISTER_UP,
		PRHK_LISTER_DOWN,
		PRHK_SELECT_UP,
		PRHK_SELECT_DOWN,

		PRHK_MAX,
	};

#ifdef GET_HK_DEFAULTS

static struct HotkeyInfo {
		char *Key;
		BOOL Global, Repeat;
	} hk_defaults[] = {
		{"lcommand shift p", TRUE, FALSE},
		{"h", FALSE, FALSE},
		{"return", FALSE, FALSE},
		{"shift space", FALSE, FALSE},
		{"space", FALSE, FALSE},
		{"shift right", FALSE, FALSE},
		{"shift left", FALSE, FALSE},
		{"q", FALSE, FALSE},
		{"a", FALSE, FALSE},
		{"m", FALSE, FALSE},
		{"delete", FALSE, FALSE},
		{"", FALSE, FALSE},
		{"l", FALSE, FALSE},
		{"", FALSE, FALSE},
		{"", FALSE, FALSE},
		{"f2", FALSE, FALSE},
		{"f1", FALSE, FALSE},
		{"?", FALSE, FALSE},
		{"shift up", FALSE, TRUE},
		{"shift down", FALSE, TRUE},
		{"right", FALSE, TRUE},
		{"left", FALSE, TRUE},
		{"ctrl up", FALSE, TRUE},
		{"ctrl down", FALSE, TRUE},
		{"up", FALSE, TRUE},
		{"down", FALSE, TRUE},
		{NULL, FALSE, FALSE}
	};
#endif


#ifdef GET_HK_NAMES
static char *hk_names[] = {
		"Show GUI",
		"Hide GUI",
		"Play selected entry",
		"Stop playback",
		"Pause playback",
		"Play Next",
		"Play Previous",
		"Quit Prayer",
		"Add files to playlist",
		"Select play mode",
		"Remove Entry",
		"Remove Entry (extended)",
		"Load Playlist",
		"Load Playlist (extended)",
		"Save Playlist",
		"Sort Playlist",
		"Open preferences window",
		"About Prayer...",
		"Step Volume UP",
		"Step Volume DOWN",
		"Step Position FORWARD",
		"Step Position BACKWARD",
		"Scroll Lister UP",
		"Scroll Lister DOWN",
		"Select File ABOVE",
		"Select File BELOW",
		NULL,
	};
#endif


#define PRF_ALWAYS_ADD_ICON	(1L << 0)

void InitPrayerPrefs(BYTE notify);

// Get a COPY of preferences NOTE: MUST free it with FreePrayerPrefs
struct PrayerPrefs *GetPrayerPrefs(void);

// Free preferences got from GetPrayerPrefs()
void FreePrayerPrefs(struct PrayerPrefs *prefs);

// Open preferences window
void EditPrayerPrefs(char *Where);

// Force Quit (Cancel) on prefs window
void ExitPrayerPrefs(void);

#endif /*  _PRAYER2_PREFS_H_ */
